@echo off& setlocal enabledelayedexpansion&set com=-c%~1& if "%~1"=="" (
 echo.&echo %~n0 1.2: Display CM11A output.  2/9/18 paulhoule.com& echo.
 echo Loops forever echoing X10 addrs/funcs that come in from CM11A.
 echo 1st arg= port number 1-n, or . to use the highest COM port.
 echo {2nd arg}= text status file [1 line] of currently on devices
 echo {3rd arg}= .bat to call between CM11A polls [minimum once per 2 sec]
 exit /b
)
if "%com%"=="-c." for /f %%c in ('phcom m') do set com=%%c
if "%com%"=="-c."  echo %~n0: *** Can't find highest COM port ***& exit /b
set cmd=echo --poll empty--& set tim=0
set ds=#.& if not "%~2"=="" (if not exist %2 echo #.>%2
  set d=.& for /f "usebackq" %%d in (%2) do set ds=%%d& set d=%%d.
  if not "!d:~-3!"=="#.." echo %~n0: *** status file error: %2 ***& exit /b)
if not x%3==x set cmd=call %3& set tim=2000
phcom %com% -m"4800,n,8,1" m -x0 -t%tim% -i30 >nul 2>nul
if errorlevel 1 echo %~n0: *** Error configuring port: %com:~2% ***& exit /b

set hc=meckogainfdlphbj& set dc=135 3 11157 1 9 146 4 12168 2 10
for /l %%h in (0,1,15) do set/a _lu!hc:~%%h,1!=0
set fc=AllUnitsOff AllLightsOn On Off Dim Bright AllLightsOff
set fc=%fc% ExtendedCode HailRequest HailAcknowledge PresetDim1 PresetDim2
set fc=%fc% ExtendedDataTransfer StatusOn StatusOff StatusRequest
set cr=''& set dat=.& set tim=.

:poll
rem get poll byte and act on it
set p=& for /f %%b in ('phcom %com% r -s1 -b') do set p=%%b
if not "%dat%"=="%date%" (
  set dat=%date%& phcom -c w %cr% "'%~n0 !dat!'"d a& set cr='')
if x%p%==x %cmd%& goto poll
for %%b in (5a a5) do if x%p%==x%%b goto poll%p%
call :emsg unknown poll response: %p%& goto poll

:poll5a
rem c3= terminate polling and initiate data transfer
set dm=phcom %com% x -b c3 -s10 -b10& set fm=for /f "tokens=1-2* delims= "
set l=& %fm% %%c in ('%dm%') do set l=%%c& set m=%%d& set b=%%e
if x%l%==x echo --poll5a empty--& goto poll
set s=0& if %l%==90 goto poll5a& rem ignore another 5a from CM11A
if %l% gtr 9 call :emsg invalid data length: %l%& goto poll

set t=%time:~,5%& if not "!t!d a"=="%tim%%cr%" (
  phcom -c w %cr% "'!t!'"& set cr=d a& set tim=!t!)
:nxd
if %l%==1 (goto poll) else for /f "tokens=1*" %%d in ("%b%") do (
  set/a d=%%d,f=m^&1,m/=2,l-=1,h=d/16,c=d%%16,c2=c*2& set b=%%e)
if %s% gtr 0 set/a s-=1& phcom -c w "' d=%d%'"& goto nxd
set hl=!hc:~%h%,1!& if !f!==0 (set/a d=!dc:~%c2%,2!, _lu!hl!=d
  phcom -c w "' !hl!!d!'"& goto nxd)
rem here for func data byte
set/a db=c ^& ~1& if !db!==4 set s=1& rem skip following dim/bright byte
if %c%==7 set s=2& rem skip following 2 extended code bytes (untested)
set dso=!ds!& set/a d=_lu%hl%
if %c%==0 for /l %%u in (1,1,16) do set ds=!ds:%hl%%%u.=!
if !d! neq 0 if %c% geq 2 if %c% leq 3 (
  set ds=!ds:%hl%%d%.=!& if %c%==2 set ds=!ds:#=%hl%%d%.#!)
if not !dso!==!ds! echo !ds!>%2
for %%f in (%fc%) do set/a c-=1& if !c!==-1 set f=%%f
phcom -c w "' !hc:~%h%,1!+%f%'"& goto nxd

:polla5
rem Set time/date (correctly for fun, though correctness isn't necessary)
set dt=%date%%time%
set/a sc=1%dt:~20,2% %%100, mn=(10%dt:~17,2%+60*(%dt:~14,2%^&1)) %%1000
set/a hr2=%dt:~14,2%/2, mo=1%dt:~4,2% %%100, da=(1%dt:~7,2% %%100)-1
set/a y=%dt:~10,4%, ly=8 + (^^!(y%%4) ^& (^^!^^!(y%%100) ^| ^^!(y%%400)))
set yd=31 2%ly% 31 30 31 30 31 31 30 31 30 31
set/a z=1& for %%m in (%yd%) do set/a mo-=1, z*=^^!^^!mo, da+=z*%%m
set/a dw=1, dx=128& set dy=Sun Mon Tue Wed Thu Fri Sat
for %%d in (%dy%) do set/a dx/=2& if /i %%d==%dt:~,3% set/a dw=dx
set/a dw+=128*(da/256), da%%=256, fb=0xf7, cs=(sc+mn+hr2+da+dw+fb)%%256
set dm=phcom %com% x -b 9b -b10 %sc% %mn% %hr2% %da% %dw% %fb% -s1
call :emsg setting CM11A clock& set c=& for /f %%c in ('%dm%') do set c=%%c
if x%c%==x (exit /b) else if not x%c%==x%cs% call :emsg bad checksum
rem Below clock set 0/55 ack not necessary, but doesn't hurt
set c=& for /f %%c in ('phcom %com% x 0 -s1 -b') do set c=%%c
if x%c%==x (exit /b) else if not x%c%==x55 call :emsg ack failure
goto poll

:emsg
phcom -c w %cr% "'%time:~,5% *** %* ***'" d a& set cr=''
